org.cpsolver.ifs.termination

## Class GeneralTerminationCondition<V extends Variable<V,T>,T extends Value<V,T>>

- java.lang.Object
- - org.cpsolver.ifs.termination.GeneralTerminationCondition<V,T>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Implemented Interfaces:
    TerminationCondition<V,T>

      public class GeneralTerminationCondition<V extends Variable<V,T>,T extends Value<V,T>>
      extends Object
      implements TerminationCondition<V,T>

  General implementation of termination condition.
  Solver stops when the solution is complete (all varaibles are assigned) or when a timeout is reached (expressed either by the number of iterations or by a time).
  Parameters:

  Related Solver Parameters
  Parameter | Type | Comment
  --- | --- | ---
  Termination.StopWhenComplete | `Double` | if true, solver stops when a complete solution is found
  Termination.MaxIters | `Integer` | if zero or positive, solver stops when the given number of iteration is reached
  Termination.TimeOut | `Double` | if zero or positive, solver stops when the given timeout (given in seconds) is reached

  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses.
  Author:
    Tomáš Müller
  See Also:
    `Solver`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static org.apache.logging.log4j.Logger` | `sLogger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GeneralTerminationCondition(DataProperties properties)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canContinue(Solution<V,T> currentSolution)` Returns true when the solver can continue with the next iteration

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### sLogger

          protected static org.apache.logging.log4j.Logger sLogger

  - ### Constructor Detail

    - #### GeneralTerminationCondition

          public GeneralTerminationCondition(DataProperties properties)

  - ### Method Detail

    - #### canContinue

          public boolean canContinue(Solution<V,T> currentSolution)

      Description copied from interface: `TerminationCondition`
      Returns true when the solver can continue with the next iteration
      Specified by:
        `canContinue` in interface `TerminationCondition<V extends Variable<V,T>,T extends Value<V,T>>`
      Parameters:
        `currentSolution` - current solution
      Returns:
        true if the solver can continue with the next iteration